import { buildProps } from 'element-plus/es/utils/vue/props/runtime';
import type { PropType } from 'vue';
import { computed } from 'vue';
import { LOGIC_SITE_CODE } from '/@/constants';
import { requestProps } from '/@/projectCom/common';

/**
 * 右侧内容传入参数定义
 */
export const mainContentProps = buildProps({
	selectNode: {
		type: Object,
	},
	selectTreeProps: {
		type: Object as PropType<{
			id: string;
			label: string;
			children: string;
		}>,
		default: () => ({
			id: 'ID',
			label: 'Name',
			children: 'Children',
		}),
	},
	listNode: {
		type: Object,
	},
	listTreeProps: {
		type: Object as PropType<{
			id: string;
			label: string;
			children: string;
		}>,
		default: () => ({
			id: 'ID',
			label: 'Name',
			children: 'Children',
		}),
	},
	belongType: {
		type: String,
		default: LOGIC_SITE_CODE,
	},
	...requestProps
} as const);

/**
 * 对右侧内容参数作进一步处理
 * @param props
 */
export const useContentProps = (props) => {
	const treeListID = computed(() => {
		const listID = props.listTreeProps.id;
		return props.listNode?.[listID];
	});
	const selectID = computed(() => {
		const selectID = props.selectTreeProps.id;
		return props.selectNode?.[selectID];
	});

	return {
		treeListID,
		selectID,
	};
};
